package com.winhc.dataworks.flow.touch.bean;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.apache.commons.lang3.SystemUtils;

import java.net.InetAddress;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/30 13:45
 * @Description:
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class DingMsg {
    private static final DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

    public static String msg2Md(String msg) {
        return "#### " + msg +
                "\n\n" + "> 时间：" + LocalDateTime.now().format(dtf) +
                "\n\n" + "> 系统信息：" + os();
    }

    public DingMsg(String msgLevel, String project, String flow, String task, String nodeName, String status) {
        this.msgLevel = msgLevel;
        this.project = project;
        this.flow = flow;
        this.task = task;
        this.nodeName = nodeName;
        this.status = status;
        LocalDateTime date = LocalDateTime.now();
        this.date = date.format(dtf);
        this.sysInfo = os();
    }

    private String msgLevel;
    private String project;
    private String flow;
    private String task;
    private String nodeName;
    private String status;
    private String date;
    private String sysInfo;

    public String toMd() {
        StringBuilder sb = new StringBuilder();
        return sb.append("#### ").append(msgLevel)
                .append("\n\n").append("位置：").append(project).append("：").append(flow).append("：").append(task)
                .append("\n\n").append("节点：").append(nodeName)
                .append("\n\n").append("状态：").append(status)
                .append("\n\n").append("> 时间：").append(date)
                .append("\n\n").append("> 系统信息：").append(sysInfo)
                .toString();
    }


    private static String os() {
        String osInfo = String.format(" %s , %s , %s", SystemUtils.OS_NAME, SystemUtils.OS_ARCH, SystemUtils.OS_VERSION);
        try {
            InetAddress address = InetAddress.getLocalHost();
            String addressInfo = String.format("\n\n> address: %s \n\n> hostname: %s", address.getHostAddress(), address.getHostName());
            osInfo += addressInfo;
        } catch (Exception e) {
        }
        return osInfo;
    }

    public static void main(String[] args) {
        System.out.println(os());
    }
}
