package com.winhc.dataworks.flow.touch.bean;

import lombok.*;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/24 14:53
 * @Description:
 */
@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class TaskInfo {
    private String project;
    private String flow;
    private String taskName;
    private Long dagId;

    public String getKey() {
        return project + ":" + flow + ":" + taskName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        TaskInfo taskInfo = (TaskInfo) o;

        return new EqualsBuilder()
                .append(project, taskInfo.project)
                .append(flow, taskInfo.flow)
                .append(taskName, taskInfo.taskName)
                .append(dagId, taskInfo.dagId)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(project)
                .append(flow)
                .append(taskName)
                .append(dagId)
                .toHashCode();
    }
}
