package com.winhc.dataworks.flow.touch.configuration;

import com.aliyun.odps.Odps;
import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.helospark.lightdi.annotation.Autowired;
import com.helospark.lightdi.annotation.Bean;
import com.helospark.lightdi.annotation.Configuration;

/**
 * @Author: XuJiakai
 * @Date: 2020/7/6 17:52
 * @Description:
 */
@Configuration
public class OdpsConfiguration {
    @Autowired
    private DataWorksAccessProperties project;
    private static final String endPoint = "http://service.odps.aliyun.com/api";

    @Bean
    public Odps odps(){
        Account account = new AliyunAccount(project.getAccessKeyId(), project.getAccessKeySecret());
        Odps odps = new Odps(account);
        odps.setEndpoint(endPoint);
        odps.setDefaultProject("winhc_eci_dev");
        return odps;
    }
}
