--odps sql
--********************************************************************--
--author:yyn
--create time:2020-06-24 14:18:55
--需打平并再折叠的维度增量数据插入、复制方案
--${PROJECT},空间名
--${DIM_TABLE},维度表，如：company_icp，下面会在各个层次添加前缀，如：winhc_eci_dev.inc_ads_company_icp
--${DS},当天分区
--${DIM_COLUMS},维度表的字段集，不含rowkey、cid、cids、new_cid、new_cids
--${DIM_LIST_COLUMS},维度LIST表的字段集，不含rowkey、cid、cids、new_cid、new_cids
--${DUPLI_COLS},维度表的去重字段集
--********************************************************************--
--1 将增量维度ods表打平
INSERT OVERWRITE TABLE ${PROJECT}.inc_tmp_${DIM_TABLE}
SELECT  cid,${DIM_COLUMS}
FROM    ${PROJECT}.inc_ods_${DIM_TABLE} a
LATERAL VIEW explode(split(cids,';')) b AS cid
WHERE   ds >= ${DS}
AND     cids IS NOT NULL
AND     trim(cids) <> ''
;
--2 再取得当天企业增量数据
WITH MAPPING AS(
    SELECT  cid,current_cid as new_cid
    FROM    ${PROJECT}.inc_ods_company
    WHERE   ds >= ${DS}
    AND     cid IS NOT NULL
    AND     current_cid IS NOT NULL
    GROUP BY cid,current_cid
)
--3 替换最新cid、去重、复制方案形成List表
INSERT OVERWRITE TABLE  ${PROJECT}.inc_ads_${DIM_TABLE}_list PARTITION(ds=${DS})
SELECT  CONCAT_WS('_',new_cid,id) AS rowkey
        --,"0" as flag
        ,CAST(new_cid as string) AS new_cid
        ,cid
        ,${DIM_LIST_COLUMS}
FROM    (
        SELECT
                *
                ,ROW_NUMBER() OVER (PARTITION BY ${DUPLI_COLS} ORDER BY update_time DESC ) num
        FROM    (
                SELECT
                        c.*
                        ,coalesce(d.new_cid,c.cid) AS new_cid
                FROM    ${PROJECT}.inc_tmp_${DIM_TABLE} c
                LEFT JOIN MAPPING d
                ON      c.cid = d.cid
                ) e
        ) f
WHERE   num =1
UNION ALL
SELECT  CONCAT_WS('_',new_cid,id) AS rowkey
--        ,"1" as flag
        ,CAST(new_cid as string) AS new_cid
        ,cid
        ,${DIM_LIST_COLUMS}
FROM    (
            SELECT  a.new_cid
                    ,${DIM_LIST_COLUMS}
                    ,a.cid
                    ,ROW_NUMBER() OVER (PARTITION BY ${DUPLI_COLS} ORDER BY update_time DESC ) num
            FROM    MAPPING a
            JOIN    (
                        SELECT  new_cid AS cid
                                ,${DIM_LIST_COLUMS}
                        FROM    ${PROJECT}.inc_ads_${DIM_TABLE}_list
                        WHERE   ds >= ${DS}
                        UNION ALL
                        SELECT  new_cid AS cid
                                ,${DIM_LIST_COLUMS}
                        FROM    ${PROJECT}.ads_${DIM_TABLE}_list
                        WHERE   ds >= ${DS}
                    ) b
            ON      a.cid = b.cid
        ) c
WHERE   num = 1
;
-- 4 主表按照id去重落库
INSERT OVERWRITE TABLE  ${PROJECT}.inc_ads_${DIM_TABLE} PARTITION(ds=${DS})
SELECT  cids AS new_cids,cids,${DIM_COLUMS}
FROM    (
            SELECT  cids AS new_cids,cids,${DIM_COLUMS}
                    ,ROW_NUMBER() OVER (PARTITION BY id ORDER BY update_time DESC ) num
            FROM    ${PROJECT}.inc_ods_${DIM_TABLE}
            WHERE   ds >= ${DS}
            AND     cids IS NOT NULL
            AND     trim(cids) <> ''
        ) a
WHERE   num = 1
;