--odps sql
--********************************************************************--
--author:yyn
--create time:2020-06-28 13:53:15
--土地抵押维度增量数据插入、复制方案
--${PROJECT},空间名
--${PROJECT_MAP},company_map空间名，测试用
--${DS},当天分区
--********************************************************************--

INSERT OVERWRITE TABLE ${PROJECT}.inc_tmp_company_land_mortgage PARTITION (ds=${DS})
SELECT --只有抵押权人
    CONCAT_WS("_",new_cid,id) AS rowkey,
--    NVL(B.new_cid,A.mortgagor_cid)   AS mortgagor_cid ,--没有抵押人
--    NVL(B.new_cid,A.mortgagee_cid)   AS new_cid,--这里仅做到基本与ods层相同即可，new_cid交由后续节点处理
    cid,
    'mortgagee' AS  type,
    id                      ,
--	mortgagor_cid           ,
--	mortgagee_cid           ,
	land_mark               ,
	land_num                ,
	land_aministrative_area ,
	land_loc                ,
	land_area               ,
	other_item_num          ,
	use_right_num           ,
	mortgagor               ,
	mortgagee               ,
	nature                  ,
	use_for                 ,
	use_type                ,
	area                    ,
	evaluate_amount         ,
	mortgage_amount         ,
	source_url              ,
	start_date,
	end_date,
	create_time,
	update_time,
	deleted
FROM ${PROJECT}.inc_ods_company_land_mortgage AS A
LEFT JOIN ${PROJECT_MAP}.company_map AS B
ON A.mortgagee_cid=B.cid
WHERE A.ds>${DS}
AND A.mortgagor_cid is NULL--没有抵押人
AND A.mortgagee_cid is NOT NULL--但有抵押权人
UNION --只有抵押人
SELECT
    CONCAT_WS("_",new_cid,id) AS rowkey,
--    NVL(B.new_cid,A.mortgagor_cid)   AS new_cid ,
    cid,
--    NVL(B.new_cid,A.mortgagee_cid)   AS cid,--没有抵押权人
    'mortgagor' AS  type,
    id                     ,
--	mortgagor_cid           ,
--	mortgagee_cid           ,
	land_mark               ,
	land_num                ,
	land_aministrative_area ,
	land_loc                ,
	land_area               ,
	other_item_num          ,
	use_right_num           ,
	mortgagor               ,
	mortgagee               ,
	nature                  ,
	use_for                 ,
	use_type                ,
	area                    ,
	evaluate_amount         ,
	mortgage_amount         ,
	source_url              ,
	start_date,
	end_date,
	create_time,
	update_time,
	deleted
FROM ${PROJECT}.inc_ods_company_land_mortgage AS A
LEFT JOIN ${PROJECT_MAP}.company_map AS B
ON A.mortgagor_cid=B.cid
WHERE A.ds>${DS}
AND A.mortgagor_cid is NOT NULL--但有抵押人
AND A.mortgagee_cid is NULL--没有抵押权人
UNION--抵押人与抵押权人为同一人或企业（cid)
SELECT
    CONCAT_WS("_",new_cid,id) AS rowkey,
--    NVL(B.new_cid,A.mortgagor_cid)   AS new_cid ,
    cid,
--    NVL(B.new_cid,A.mortgagee_cid)   AS cid,--与mortgagor_cid相同
    'bothsame' AS  type,
    id                     ,
--	mortgagor_cid           ,
--	mortgagee_cid           ,
	land_mark               ,
	land_num                ,
	land_aministrative_area ,
	land_loc                ,
	land_area               ,
	other_item_num          ,
	use_right_num           ,
	mortgagor               ,
	mortgagee               ,
	nature                  ,
	use_for                 ,
	use_type                ,
	area                    ,
	evaluate_amount         ,
	mortgage_amount         ,
	source_url              ,
	start_date,
	end_date,
	create_time,
	update_time,
	deleted
FROM ${PROJECT}.inc_ods_company_land_mortgage AS A
LEFT JOIN ${PROJECT_MAP}.company_map AS B
ON A.mortgagor_cid=B.cid
WHERE A.ds>${DS}
AND A.mortgagor_cid is NOT NULL AND A.mortgagor_cid=A.mortgagee_cid--抵押人与抵押权人相同
UNION--抵押人与抵押权人都有但不为同一人或企业(cid)，拆成二条的第一条（抵押人）
SELECT
    CONCAT_WS("_",new_cid,id) AS rowkey,
--    NVL(B.new_cid,A.mortgagor_cid)   AS new_cid ,--一分为二的第一条
    cid,
--    NVL(B.new_cid,A.mortgagee_cid)   AS cid,
    'bothone' AS  type,
    id                      ,
--	mortgagor_cid           ,
--	mortgagee_cid           ,
	land_mark               ,
	land_num                ,
	land_aministrative_area ,
	land_loc                ,
	land_area               ,
	other_item_num          ,
	use_right_num           ,
	mortgagor               ,
	mortgagee               ,
	nature                  ,
	use_for                 ,
	use_type                ,
	area                    ,
	evaluate_amount         ,
	mortgage_amount         ,
	source_url              ,
	start_date,
	end_date,
	create_time,
	update_time,
	deleted
FROM ${PROJECT}.inc_ods_company_land_mortgage AS A
LEFT JOIN ${PROJECT_MAP}.company_map AS B
ON A.mortgagor_cid=B.cid
WHERE A.ds>${DS}
AND A.mortgagor_cid is NOT NULL AND A.mortgagee_cid is NOT NULL AND A.mortgagor_cid!=A.mortgagee_cid--抵押人、抵押权人都有但不相同
UNION--抵押人与抵押权人都有但不为同一人或企业(cid)，拆成二条的第二条（抵押权人）
SELECT
    CONCAT_WS("_",new_cid,id) AS rowkey,
--    NVL(B.new_cid,A.mortgagor_cid)   AS cid ,
--    NVL(B.new_cid,A.mortgagee_cid)   AS new_cid,--一分为二的第二条
    cid,
    'bothtwo' AS  type,
    id                      ,
--	mortgagor_cid           ,
--	mortgagee_cid           ,
	land_mark               ,
	land_num                ,
	land_aministrative_area ,
	land_loc                ,
	land_area               ,
	other_item_num          ,
	use_right_num           ,
	mortgagor               ,
	mortgagee               ,
	nature                  ,
	use_for                 ,
	use_type                ,
	area                    ,
	evaluate_amount         ,
	mortgage_amount         ,
	source_url              ,
	start_date,
	end_date,
	create_time,
	update_time,
	deleted
FROM ${PROJECT}.inc_ods_company_land_mortgage AS A
LEFT JOIN ${PROJECT_MAP}.company_map AS B
ON A.mortgagee_cid=B.cid
WHERE A.ds>${DS}
AND A.mortgagor_cid is NOT NULL AND A.mortgagee_cid is NOT NULL AND A.mortgagor_cid!=A.mortgagee_cid--抵押人、抵押权人都有但不相同
;
