package com.winhc.dataworks.flow.touch.service;

import com.helospark.lightdi.annotation.Autowired;
import com.helospark.lightdi.annotation.Service;
import com.winhc.dataworks.flow.touch.bean.SparkJobInfo;
import com.winhc.dataworks.flow.touch.cmd.OdpsCmd;
import com.winhc.dataworks.flow.touch.configuration.DataWorksAccessProperties;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/8/5 14:43
 * @Description:
 */
@Service
public class OdpsCmdService {
    private DataWorksAccessProperties dataWorksAccessProperties;
    private OdpsCmd odpsCmd;



    @Autowired
    public OdpsCmdService(DataWorksAccessProperties dataWorksAccessProperties) {
        this.dataWorksAccessProperties = dataWorksAccessProperties;
        this.odpsCmd = new OdpsCmd("", dataWorksAccessProperties.getAccessKeyId(), dataWorksAccessProperties.getAccessKeySecret(), "");

    }

    public List<String> getTimeOutJobs(Long minutes) {
        List<SparkJobInfo> running = odpsCmd.query("RUNNING");
        return running.stream().filter(e -> e.runningMinutes() >= minutes).map(SparkJobInfo::getInstanceId).collect(Collectors.toList());
    }

    public Boolean kill(String instanceId) {
        return odpsCmd.kill(instanceId);
    }


    private static final String basePath = "C:\\Users\\x\\Downloads\\Compressed\\odpscmd_public";



}
