package com.winhc.dataworks.flow.touch.service;

import com.helospark.lightdi.annotation.Service;
import com.winhc.dataworks.flow.touch.utils.DateUtils;
import com.winhc.dataworks.flow.touch.utils.DingUtils;
import com.winhc.dataworks.flow.touch.utils.OkHttpUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;

/**
 * @Author: XuJiakai
 * @Date: 2020/8/7 11:52
 * @Description:
 */
@Slf4j
@Service
@AllArgsConstructor
public class QueryService {
    private static final String baseUrl = "http://47.101.221.131:8085";

    private OkHttpUtils client;
    private DingUtils dingUtils;
    private static Boolean send = false;

    public Boolean isSuccess() {
        try {
            return "4".equals(client.get(baseUrl + "/query/" + DateUtils.getMinusDay(0)));
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            if (!send) {
                send = true;
                dingUtils.send(e.getMessage());
            }
        }
        return false;
    }

}
