package com.winhc.dataworks.flow.touch.utils;

import com.helospark.lightdi.annotation.Component;
import lombok.AllArgsConstructor;
import okhttp3.*;

import java.io.IOException;
import java.util.Objects;

/**
 * @Author: XuJiakai
 * @Date: 2020/8/7 11:54
 * @Description:
 */
@Component
@AllArgsConstructor
public class OkHttpUtils {
    private OkHttpClient client;
    private static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");

    public String post(String url, String json) throws IOException {
        RequestBody body = RequestBody.create(JSON, json);
        try (Response response = client.newCall((new Request.Builder()).url(url).post(body).build()).execute()) {
            return parseBody(response);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    public String get(String url) throws IOException {
        try (Response response = client.newCall(new Request.Builder().url(url).get().build()).execute()) {
            return parseBody(response);
        }
    }

    private static String parseBody(Response response) throws IOException {
        return response == null ? "" : response.isSuccessful() ? Objects.requireNonNull(response.body()).string() : "";
    }


}
