package com.winhc.dataworks.flow.touch.utils;

import com.winhc.dataworks.flow.touch.cmd.OdpsCmd;
import lombok.extern.slf4j.Slf4j;

import java.util.Queue;

/**
 * @Author: XuJiakai
 * @Date: 2020/8/17 11:12
 * @Description:
 */
@Slf4j
public class SparkDaemonKill extends Thread {

    private Queue<String> queue;
    private OdpsCmd odpsCmd;

    /**
     * @param project_name 工程名
     * @param access_id    key
     * @param access_key   secret
     * @param basePath     odps根目录
     * @param queue        对列
     */
    public SparkDaemonKill(String project_name, String access_id, String access_key, String basePath, Queue<String> queue) {
        super.setDaemon(true);
        super.setName("spark-kill-daemon");
        this.queue = queue;
        this.odpsCmd = new OdpsCmd(project_name, access_id, access_key, basePath);
    }


    @Override
    public void run() {
        try {
            while (true) {
                String poll = queue.poll();
                if (poll != null) {
                    odpsCmd.kill(poll);
                }
                if (queue.isEmpty()) {
                    Thread.sleep(10000);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }
}
