package com.winhc.dataworks.flow.touch.utils;

import java.util.HashMap;
import java.util.Map;
import java.util.Queue;
import java.util.concurrent.ArrayBlockingQueue;

/**
 * @Author: XuJiakai
 * @Date: 2020/8/17 11:20
 * @Description:
 */
public class SparkDaemonUtils {


    public static final Long sparkTimeoutMinutes = 90L;

    private static final Map<String, Queue<String>> queueMap = new HashMap<>();

    private static void createOrIgnore(String project) {
        if (!queueMap.containsKey(project)) {
            synchronized (SparkDaemonUtils.class) {
                if (!queueMap.containsKey(project)) {
                    queueMap.put(project, new ArrayBlockingQueue<>(100));
                }
            }
        }
    }

    public static Queue<String> getQueue(String project) {
        createOrIgnore(project);
        return queueMap.get(project);
    }

    public static boolean put(String project, String val) {
        if (!queueMap.containsKey(project)) {
            throw new RuntimeException("对列没有进行初始化！");
        }
        queueMap.get(project).add(val);
        return true;
    }
}
